public class designPrimer 
{
    public designPrimer() {}

    // a method to get the forward primer from upstrand
    public String getForward (String s, int p, char ch)
    {
        int p1 = s.length();
        if (p >= p1) return "Wrong";

        String s1 = s.substring(0, p);
 
        s1 += java.lang.String.valueOf(ch);
        s1 += s.substring(p+1);
 
        return s1;
    }
 
    // a method to get the reverse primer frow downstrand
    public String getReverse (String s, int p, char ch)
    {
	//first insert the mismatch (into the up strand version)
	String s1 = getForward (s, p, ch);
        int len = s1.length();

	//then reverse the order
	int i = 0;
        String s2 = "";
        for (i=0; i<len; i++)   // reverse the order first -> 5'-3'
            s2 += java.lang.String.valueOf(s1.charAt(len-1-i));
 
	//get the primer
        int j = 0;
        String s3 = "";
        for (j=0; j<len; j++)   // reverse nuclotides in antisense strand
        {
            if (s2.charAt(j) == 'A') s3 += 'T';
            else if (s2.charAt(j) == 'T') s3 += 'A';
            else if (s2.charAt(j) == 'G') s3 += 'C';
            else if (s2.charAt(j) == 'C') s3 += 'G';
            else if (s2.charAt(j) == 'N') s3 += 'N';
        }
 
        return s3;
    }
    
    // a method to get the reverse outer primer
    public String getReverse (String s)
    {
        int i = 0;
        int len = s.length();
        String s1 = "";
        String s2 = "";
        for (i=0; i<len; i++)   //complementarity replacement
        {
            if (s.charAt(i) == 'A') s1 += 'T';
            else if (s.charAt(i) == 'T') s1 += 'A';
            else if (s.charAt(i) == 'G') s1 += 'C';
            else if (s.charAt(i) == 'C') s1 += 'G';
            else if (s.charAt(i) == 'N') s1 += 'N';
        }
 
        //reverse the order to 5'-3'
        for (i=0; i<len; i++)
            s2 += java.lang.String.valueOf(s1.charAt(len-1-i));
 
        return s2;
    }
}
